#include <iostream>
#include <fstream>
using namespace std;

const int MAXS = 100;
const int MAXV = 100;
const int MAXP = 100;

enum TipoVisita {ECOGRAFIA, TAC, RISONANZA};

struct Paziente {
  char nome[MAXS];
  char cognome[MAXS];
  int identif;
};

struct ElencoPazienti {
  Paziente paz[MAXP];
  int numPaz;
};

struct Data {
  int giorno;
  int mese;
  int anno;
};

struct Visita {
  Data data;
  int idPaz; 
  TipoVisita tipVis;
};

struct Calendario {
  Visita vis[MAXV];
  int numVis;
};
 

bool caricaElenco(ElencoPazienti* pe, const char n[]);

int nuovaVisita(const ElencoPazienti* pe, Calendario* pc, Visita v);

bool primoPaziente(const ElencoPazienti* pe, const Calendario* pc, TipoVisita tv, Paziente* pp);

int trovaVisite(const Calendario* pc, int id, Visita vv[]);

void stampaReport(const ElencoPazienti* pe, const Calendario* pc, int id);

void menu(){
  cout << "\n\n---------------------" << endl;
  cout << "1) carica elenco" << endl;
  cout << "2) nuova visita" << endl;
  cout << "3) primo paziente" << endl;
  cout << "4) trova visite" << endl;
  cout << "5) stampa report" << endl;
  cout << "6) stampa elenco" << endl;
  cout << "7) stampa calendario" << endl;
  cout << "0) esci" << endl;
  cout << "Scelta? ";
}

Data leggiData(){
  Data d;
  cout << "Inserisci giorno: ";
  cin >> d.giorno;
  cout << "Inserisci mese: ";
  cin >> d.mese;
  cout << "Inserisci anno: ";
  cin >> d.anno;
  return d;
}

TipoVisita leggiTipoVisita(){
  char c;
  while(true) {
    cout << "Inserisci tipo visita (t=TAC, e=ECOGRAFIA, r=RISONANZA): ";
    cin >> c;
    switch(c) {
      case 'e': case 'E':
        return ECOGRAFIA;
      case 't': case 'T':
        return TAC;
      case 'r': case 'R':
        return RISONANZA;
    }
  }
}

Visita leggiVisita(){
  Visita v;
  v.data = leggiData();
  cout << "Inserisci id paziente: ";
  cin >> v.idPaz;
  v.tipVis = leggiTipoVisita();
  return v;
}

void stampaPaziente(Paziente p) {
  cout << p.nome << ' ' << p.cognome << ' ' << p.identif;
}
  
void stampaVis(Visita v){
  cout << v.data.giorno << '/' << v.data.mese << '/' << v.data.anno << '\t'
       << v.idPaz << '\t';
  switch(v.tipVis) {
    case RISONANZA:
      cout << 'R';
      break;
    case ECOGRAFIA:
      cout << 'E';
      break;
    case TAC:
      cout << 'T';
  }
}

int main(){
  ElencoPazienti ele;
  Calendario cal;
  ele.numPaz = 0;
  cal.numVis = 0;  
  char s;
  bool res;
  int q, id;
  Visita v;
  Paziente p;
  TipoVisita tv;
  Visita vv[MAXV];

  while(true) { 
    menu();
    cin >> s;
    switch(s) {
      case '1':
        cout << "Provo a caricare l'elenco dal file preparato dal docente" << endl;
        res = caricaElenco(&ele, "elenco.txt");
        if(!res) cout << "Caricamento fallito" << endl;
        else cout << "Caricamento eseguito" << endl;
        break;
      case '2':
        v = leggiVisita();
        q = nuovaVisita(&ele, &cal, v);
        if(q<0) cout << "Inserimento fallito" << endl;
        else
          cout << "Inserimento eseguito nella posizione " << q << endl;
        break;
      case '3': 
        tv = leggiTipoVisita();
        res = primoPaziente(&ele, &cal, tv, &p);
        if(!res) cout << "Non ci sono pazienti per tale tipo di visita" << endl;
        else {
          cout << "Il primo paziente per tale tipo di visita e': ";
          stampaPaziente(p); cout << endl;
        }
        break;
    case '4':
        cout << "Inserisci id: ";
        cin >> id;
        q = trovaVisite(&cal, id, vv);
        cout << "Sono state trovate " << q << " visite" << endl;
        for(int i=0; i<q; i++) {
          stampaVis(vv[i]); cout << endl;
        }
        break;
    case '5': 
        cout << "Inserisci id: ";
        cin >> id;
        stampaReport(&ele, &cal, id);
        break; 
    case '6':
      cout << "Elenco pazienti:" << endl;
      for(int i=0; i<ele.numPaz; i++){ 
        stampaPaziente(ele.paz[i]); cout << endl; 
      }
      break;
    case '7':
      cout << "Elenco visite:" << endl;
      for(int i=0; i<cal.numVis; i++) {
        stampaVis(cal.vis[i]); cout << endl;
      }
      break;
    case '0':
      return 0;
    default:
      cout << "Scelta non valida" << endl;
    }
  }
}
